package com.candidjava.springmvc.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import com.candidjava.springmvc.bean.StudentBean;

@Controller
public class StudentController
{

	// **********************************************************

	// ModelAttribute at method level : common for all requests

	@ModelAttribute
	public void addingCommonObjects(Model model)
	{
		model.addAttribute("msg", "Student Registration Details");
	}

	// ************************************************************************************************************

	// ModelAttribute at parameter level

	@RequestMapping("/Register.htm")
	public ModelAndView getFormData(@ModelAttribute("ob")StudentBean sb, BindingResult result)
	{
		// BindingResult is used for validation purpose
		// Print the entire data
		
		if (!result.hasErrors())
		{
			System.out.println("Reg No..................." + sb.getRegno());
			System.out.println("Name..................." + sb.getSname());
			System.out.println("Course..................." + sb.getCourse());
			System.out.println("City..................." + sb.getAddressBean().getCity());
			System.out.println("State..................." + sb.getAddressBean().getState());
			System.out.println("Pincode..................." + sb.getAddressBean().getPincode());

		}
		else
		{
			System.out.println("Error!!!!!!!!!!!");
		}

		ModelAndView model = new ModelAndView("page");
		model.addObject("sb", sb);  //both will work it will automatically injected to on object
		//model.addObject("ob", sb);
		return model;
	}
	
	// ************************************************************************************************************
		
	
		// ModelAttribute at method level
	
		@RequestMapping("/Register1.htm")
		@ModelAttribute("ob")
		public ModelAndView setFormData(StudentBean sb, BindingResult result)
		{
						
			if (!result.hasErrors())
			{
				System.out.println("Reg No..................." + sb.getRegno());
				System.out.println("Name..................." + sb.getSname());
				System.out.println("Course..................." + sb.getCourse());
				System.out.println("City..................." + sb.getAddressBean().getCity());
				System.out.println("State..................." + sb.getAddressBean().getState());
				System.out.println("Pincode..................." + sb.getAddressBean().getPincode());

			}
			else
			{
				System.out.println("Error!!!!!!!!!!!");
			}

			ModelAndView model = new ModelAndView("page");
			model.addObject("ob",sb);  //In this approach it will only work
			//model.addObject("sb",sb);
			return model;
		}
		
		// ************************************************************************************************************
		@RequestMapping("/Register2.htm")
		public String processForm(@ModelAttribute("ob") StudentBean sb,Model model,BindingResult result)
		{
			if (!result.hasErrors())
			{
				System.out.println("Reg No..................." + sb.getRegno());
				System.out.println("Name..................." + sb.getSname());
				System.out.println("Course..................." + sb.getCourse());
				System.out.println("City..................." + sb.getAddressBean().getCity());
				System.out.println("State..................." + sb.getAddressBean().getState());
				System.out.println("Pincode..................." + sb.getAddressBean().getPincode());

			}
			else
			{
				System.out.println("Error!!!!!!!!!!!");
			}		
			
			
			model.addAttribute(sb);			
			
		   
		    return "page";
		}
		
		//*******************************************************
		
		

}